#Code for 4WD: Omnidirectional Robot
from machine import Pin,PWM # Importing Pulse with modulation to give analogue behavior(adjustable values)
from time import sleep 
import time # importing time and sleep to set duration of actions

trigger= Pin(9,Pin.OUT)  #connect ultrasonic Vcc to 5V 
echo= Pin(8,Pin.IN) # connects ultrasonic echo pin(output pin)to GPIO pin(sends on/off signals to sensor) 

trigger2= Pin(7, Pin.OUT) # second ultraonic sensor
echo2= Pin(6, Pin.IN)

trigger3= Pin(27, Pin.OUT) # third ultrasonic sensor
echo3= Pin(28, Pin.IN)
x=0 # counter for number of obstacles to stop the robot



motor1A=PWM(Pin(17,Pin.OUT))
motor1B=PWM(Pin(16,Pin.OUT))
motor2A=PWM(Pin(15,Pin.OUT))
motor2B=PWM(Pin(14,Pin.OUT))

motor3A=PWM(Pin(13,Pin.OUT))
motor3B=PWM(Pin(12,Pin.OUT))
motor4A=PWM(Pin(11,Pin.OUT))
motor4B=PWM(Pin(10,Pin.OUT))



motor1A.freq(100) #100 freq is full power 
motor1B.freq(100)
motor2A.freq(100)
motor2B.freq(100)
motor3A.freq(100)
motor3B.freq(100)
motor4A.freq(100)
motor4B.freq(100)

#function to move forward
def forward():
    motor1A.duty_u16(0) #top left #make this number a variable for speed control max speed at 65535
    motor1B.duty_u16(23000) 
    motor2A.duty_u16(0) #top right
    motor2B.duty_u16(22000) # DECREASED POWER TO MOTORS 2B and #3B to make it go straight
    motor3A.duty_u16(0)  #bottom left
    motor3B.duty_u16(22000)     #left and right motors are wired in opposite directions
    motor4A.duty_u16(23000) # bottom right-- forward
    motor4B.duty_u16(0) #backwards
    #sleep(num_of_secs)
#function moves backward
def reverse(): 
    motor1A.duty_u16(21500) #make this number a variable for speed control max speed at 65535 #changed from 20000 to 21500
    motor1B.duty_u16(0) 
    motor2A.duty_u16(21500)
    motor2B.duty_u16(0) 
    motor3A.duty_u16(21500) 
    motor3B.duty_u16(0)     #left and right motors are wired in opposite directions
    motor4A.duty_u16(0)
    motor4B.duty_u16(21500)
    #sleep(num_of_secs)



#function to shift right
def turn_right(): # shifts right using mecanum wheels
    #stop(1)
    motor1A.duty_u16(0) #make this number a variable for speed control max speed at 65535
    motor1B.duty_u16(30000) #move left motors faster than right
    motor2A.duty_u16(30000)
    motor2B.duty_u16(0) 
    motor3A.duty_u16(25000) 
    motor3B.duty_u16(0)     #left and right motors are wired in opposite directions
    motor4A.duty_u16(25000)
    motor4B.duty_u16(0)
    #sleep(num_of_secs)
    #stop(3)


#function to move left
def turn_left(): #shifts left using mecanum wheels
    #stop(1)
    motor1A.duty_u16(31000) #make this number a variable for speed control max speed at 65535
    motor1B.duty_u16(0)#move right motors faster than left
    motor2A.duty_u16(0)
    motor2B.duty_u16(31000) 
    motor3A.duty_u16(0) 
    motor3B.duty_u16(25000)     #left and right motors are wired in opposite directions
    motor4A.duty_u16(0)
    motor4B.duty_u16(25000)
    #sleep(num_of_secs)
    #stop(3)
#function to stop
def stop(num_of_secs):
    motor1A.duty_u16(0)
    motor1B.duty_u16(0) 
    motor2A.duty_u16(0)
    motor2B.duty_u16(0) 
    motor3A.duty_u16(0) 
    motor3B.duty_u16(0)
    motor4A.duty_u16(0)
    motor4B.duty_u16(0)
    sleep(num_of_secs)
    
   
# def diagonal_right():
#     stop(3)
#     motor1A.duty_u16(0) #make this number a variable for speed control max speed at 65535
#     motor1B.duty_u16(28000) #move left motors faster than right
#     motor2A.duty_u16(0)
#     motor2B.duty_u16(0) 
#     motor3A.duty_u16(0) 
#     motor3B.duty_u16(0)     #left and right motors are wired in opposite directions
#     motor4A.duty_u16(0)
#     motor4B.duty_u16(25000)
#     sleep(1.3) 
#     stop(3)
# 
# 
# def diagonal_left():
#     stop(3)
#     motor1A.duty_u16(0) #make this number a variable for speed control max speed at 65535
#     motor1B.duty_u16(0) #move left motors faster than right
#     motor2A.duty_u16(0)
#     motor2B.duty_u16(28000) 
#     motor3A.duty_u16(0) 
#     motor3B.duty_u16(28000)     #left and right motors are wired in opposite directions
#     motor4A.duty_u16(0)
#     motor4B.duty_u16(0)
#     sleep(1.3) 
#     stop(3)


    
#Function to find distance of obstacles using ultrasonic sensor

def distance(): #ultrasonic sensor function
    timeelapsed=0 # how much time has gone by
    trigger.off() #reset trigger
    sleep(0.2)
    trigger.on()
    sleep(0.00001) #send a short 0.01ms trigger pulse
    trigger.off()
    while echo.value()==0:
        start_time= time.ticks_us() #save start time
    while echo.value()==1:
        stop_time=time.ticks_us() #get the arrival time
    timeelapsed = stop_time-start_time
   # multiply with the sound speed (34300 cm/s)
    obstacle_distance = (timeelapsed *0.0343)/2    # dis = speed*time speed of sound=343.2m/s  . divide by 2 as we half the distance echo travelled
    #print("distane from object is", obstacle_distance,"cm")
    return obstacle_distance #distance in cm
    
    
def distance2(): #ultrasonic sensor function(right ultrasonic sensor)
    timeelapsed=0
    trigger2.off() #reset trigger
    sleep(0.2)
    trigger2.on()
    sleep(0.00001) #send a short 0.01ms trigger pulse
    trigger2.off()
    while echo2.value()==0:
        start_time= time.ticks_us() #save start time
    while echo2.value()==1:
        stop_time=time.ticks_us() #get the arrival time
    timeelapsed = stop_time-start_time
   # multiply with the sound speed (34300 cm/s)
    obstacle_distance = (timeelapsed *0.0343)/2    # dis = speed*time speed of sound=343.2m/s  . divide by 2 as we half the distance echo travelled
    #print("distane from object is", obstacle_distance,"cm")
    return obstacle_distance #distance in cm
    right_distance= distance2()
    sleep(1)
    
def distance3(): #ultrasonic sensor function(left sensor)
    timeelapsed=0
    trigger3.off() #reset trigger
    sleep(0.2)
    trigger3.on()
    sleep(0.00001) #send a short 0.01ms trigger pulse
    trigger3.off()
    while echo3.value()==0:
        start_time= time.ticks_us() #save start time
    while echo3.value()==1:
        stop_time=time.ticks_us() #get the arrival time
    timeelapsed = stop_time-start_time
   # multiply with the sound speed (34300 cm/s)
    obstacle_distance = (timeelapsed *0.0343)/2    # dis = speed*time speed of sound=343.2m/s  . divide by 2 as we half the distance echo travelled
    #print("distane from object is", obstacle_distance,"cm")
    return obstacle_distance #distance in cm
    left_distance= distance3()
    sleep(1)
        
#     
# forward()
# sleep(2)
# stop(1)
# reverse()
# sleep(2)
# diagonal_right()
# sleep(3)
# diagonal_left()
# sleep(3)
# turn_left()
# forward()
# sleep(2)
# turn_right()
# stop(2) 

while True:
  #if distance()< 40:
  #print('stop')
#      #stop(8)              #obstacle should have moved out of way by end of this
#  if x>4:
#           forward()
#           sleep(2)# end of maze-- car should stop after certain # of turns
#           stop(10)
 if distance()<30  and x<=4: # if there is an obstacle within 30 cm and there have NOT been 4 obstacles yet
          x=x+1 # counter increases by 1 each time there is an obstacle
          #distance()
          #print("stops")
          stop(2)#if obstacle is still in front- static, then scan left & right
          #sleep(1)
          if x==4: # when counter is reached: the car goes through a small sequence of actions before stopping
              stop(4)
              turn_right()
              sleep(2)
              stop(1)
              forward()
              sleep(1.85)
              stop(3)
              turn_right()
              sleep(1.5)
              stop(1000)
          elif distance3() > 40:  #check to go in the left direction- default. If there is no obstacle on the left, move left.
                stop(1.5)
                turn_left()
                sleep(1.9)
                stop(1)
          elif distance2()> 50: #Check to go in right: if there is no obstacle on right, move right
                stop(1)
                turn_right()
                sleep(1.7)
                stop(1)
          
 else:
     forward() #if there is no obstacle, the car moves forward


     
     